import { bodyType, objectStringsType, useFetchConfig } from './types';
export default class BackendCall {
    private baseApiUrl;
    private defaultHeaders;
    private defaultSuccessFunction;
    private defaultErrorFunction;
    private useFetchConfig;
    constructor(baseApiUrl: string, defaultHeaders?: objectStringsType, defaultSuccessFunction?: Function, defaultErrorFunction?: Function, useFetchConfig?: useFetchConfig);
    handleIsShortHanded(useFetchCustomConfig?: useFetchConfig): useFetchConfig;
    postData<D, T = any>(config: {
        endPoint: string;
        bodyDefault?: bodyType;
        queryDefault?: objectStringsType;
        useFetchCustomConfig?: useFetchConfig;
    }): import("./types").useFetchType<D, T>;
    getData<D, T = any>(config: {
        endPoint: string;
        queryDefault?: objectStringsType;
        useFetchCustomConfig?: useFetchConfig;
    }): import("./types").useFetchType<D, T>;
    updateData<D, T = any>(config: {
        endPoint: string;
        bodyDefault?: bodyType;
        queryDefault?: objectStringsType;
        useFetchCustomConfig?: useFetchConfig;
    }): import("./types").useFetchType<D, T>;
    patchData<D, T = any>(config: {
        endPoint: string;
        bodyDefault?: bodyType;
        queryDefault?: objectStringsType;
        useFetchCustomConfig?: useFetchConfig;
    }): import("./types").useFetchType<D, T>;
    deleteData<D, T = any>(config: {
        endPoint: string;
        bodyDefault?: bodyType;
        queryDefault?: objectStringsType;
        useFetchCustomConfig?: useFetchConfig;
    }): import("./types").useFetchType<D, T>;
    custom<D, T = any>(config: {
        endPoint: string;
        method: string;
        bodyDefault?: bodyType;
        queryDefault?: objectStringsType;
        useFetchCustomConfig?: useFetchConfig;
    }): import("./types").useFetchType<D, T>;
}
//# sourceMappingURL=BackendCall.d.ts.map